<?php
/**
 * @package Euro2012
 * @version $Id$
 * @author ian
 * Copyright Ian Haycox, 2012
 *
 */

class Euro2012Admin extends Euro2012 {
	 
	/*
	 * Constructor
	 */
	function __construct() {
		global $wpdb;
		$wpdb->show_errors(true);  //Fixed in 1.2.4 http://trac.buddypress.org/ticket/2361
		parent::__construct();
	}

	/**
	 * Activation hook.
	 * 
	 * Create database structure
	 */
	function activate() {
		
		require_once ABSPATH . 'wp-admin/includes/upgrade.php';
		
		global $wpdb;
		
		$charset_collate = '';
		if ( $wpdb->has_cap( 'collation' ) ) {
			if ( ! empty($wpdb->charset) )
				$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
			if ( ! empty($wpdb->collate) )
				$charset_collate .= " COLLATE $wpdb->collate";
		}

		// Plugin database table version
		$db_version = "1.0";
		
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}{$this->prefix}match` (
		  `match_id` int(11) NOT NULL AUTO_INCREMENT,
		  `match_no` int(11) NOT NULL,
		  `kickoff` datetime NOT NULL,
		  `home_team_id` int(11) NOT NULL,
		  `away_team_id` int(11) NOT NULL,
		  `home_goals` int(11) NOT NULL,
		  `away_goals` int(11) NOT NULL,
		  `home_penalties` int(11) NOT NULL,
		  `away_penalties` int(11) NOT NULL,
		  `venue_id` int(11) NOT NULL,
		  `is_result` BOOL NOT NULL DEFAULT '0', 
		  `extra_time` BOOL NOT NULL DEFAULT '0', 
		  `stage_id` int(11) NOT NULL,
		  `scored` BOOL NOT NULL DEFAULT '0',
		  PRIMARY KEY (`match_id`)
		) $charset_collate";
		$ret = $wpdb->query($sql);
		if ($ret === false) {
			error_log($wpdb->last_error);
		} else {
			$count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}match");
			if (!$count) {
				$wpdb->query("INSERT INTO `{$wpdb->prefix}{$this->prefix}match` (`match_id`, `match_no`, `kickoff`, `home_team_id`, `away_team_id`, `home_goals`, `away_goals`, `home_penalties`, `away_penalties`, `venue_id`, `is_result`, `extra_time`, `stage_id`, `scored`) VALUES
						(1, 1, '2012-06-08 16:00:00', 10, 7, 0, 0, 0, 0, 1, 0, 0, 1, 0),
						(2, 2, '2012-06-08 18:45:00', 13, 2, 0, 0, 0, 0, 3, 0, 0, 1, 0),
						(3, 3, '2012-06-09 16:00:00', 9, 3, 0, 0, 0, 0, 6, 0, 0, 2, 0),
						(4, 4, '2012-06-09 18:45:00', 6, 11, 0, 0, 0, 0, 8, 0, 0, 2, 0),
						(5, 5, '2012-06-10 16:00:00', 14, 8, 0, 0, 0, 0, 2, 0, 0, 3, 0),
						(6, 6, '2012-06-10 18:45:00', 12, 1, 0, 0, 0, 0, 4, 0, 0, 3, 0),
						(7, 7, '2012-06-11 16:00:00', 5, 4, 0, 0, 0, 0, 7, 0, 0, 4, 0),
						(8, 8, '2012-06-11 18:45:00', 16, 15, 0, 0, 0, 0, 5, 0, 0, 4, 0),
						(9, 9, '2012-06-12 16:00:00', 7, 2, 0, 0, 0, 0, 3, 0, 0, 1, 0),
						(10, 10, '2012-06-12 18:45:00', 10, 13, 0, 0, 0, 0, 1, 0, 0, 1, 0),
						(11, 11, '2012-06-13 16:00:00', 3, 11, 0, 0, 0, 0, 8, 0, 0, 2, 0),
						(12, 12, '2012-06-13 18:45:00', 9, 6, 0, 0, 0, 0, 6, 0, 0, 2, 0),
						(13, 13, '2012-06-14 16:00:00', 8, 1, 0, 0, 0, 0, 4, 0, 0, 3, 0),
						(14, 14, '2012-06-14 18:45:00', 14, 12, 0, 0, 0, 0, 2, 0, 0, 3, 0),
						(15, 15, '2012-06-15 18:45:00', 15, 4, 0, 0, 0, 0, 5, 0, 0, 4, 0),
						(16, 16, '2012-06-15 16:00:00', 16, 5, 0, 0, 0, 0, 7, 0, 0, 4, 0),
						(17, 17, '2012-06-16 18:45:00', 2, 10, 0, 0, 0, 0, 3, 0, 0, 1, 0),
						(18, 18, '2012-06-16 18:45:00', 7, 13, 0, 0, 0, 0, 1, 0, 0, 1, 0),
						(19, 19, '2012-06-17 18:45:00', 11, 9, 0, 0, 0, 0, 6, 0, 0, 2, 0),
						(20, 20, '2012-06-17 18:45:00', 3, 6, 0, 0, 0, 0, 8, 0, 0, 2, 0),
						(21, 21, '2012-06-18 18:45:00', 1, 14, 0, 0, 0, 0, 2, 0, 0, 3, 0),
						(22, 22, '2012-06-18 18:45:00', 8, 12, 0, 0, 0, 0, 4, 0, 0, 3, 0),
						(23, 23, '2012-06-19 18:45:00', 4, 16, 0, 0, 0, 0, 7, 0, 0, 4, 0),
						(24, 24, '2012-06-19 18:45:00', 15, 5, 0, 0, 0, 0, 5, 0, 0, 4, 0),
						(25, 25, '2012-06-21 18:45:00', 17, 22, 0, 0, 0, 0, 1, 0, 0, 5, 0),
						(26, 26, '2012-06-22 18:45:00', 18, 21, 0, 0, 0, 0, 2, 0, 0, 5, 0),
						(27, 27, '2012-06-23 18:45:00', 19, 24, 0, 0, 0, 0, 7, 0, 0, 5, 0),
						(28, 28, '2012-06-24 18:45:00', 20, 23, 0, 0, 0, 0, 5, 0, 0, 5, 0),
						(29, 29, '2012-06-27 18:45:00', 25, 27, 0, 0, 0, 0, 7, 0, 0, 6, 0),
						(30, 30, '2012-06-28 18:45:00', 26, 28, 0, 0, 0, 0, 1, 0, 0, 6, 0),
						(31, 31, '2012-07-01 18:45:00', 29, 30, 0, 0, 0, 0, 5, 0, 0, 7, 0)");
			}
		}
		
		
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}{$this->prefix}prediction` (
		  `prediction_id` int(11) NOT NULL AUTO_INCREMENT,
		  `user_id` bigint(20) NOT NULL,
		  `match_id` int(11) NOT NULL,
		  `home_goals` int(11) NOT NULL,
		  `away_goals` int(11) NOT NULL,
		  `home_penalties` int(11) NOT NULL,
		  `away_penalties` int(11) NOT NULL,
		  `points` int(11) NOT NULL,
		  `wwhen` DATETIME NOT NULL,
		  PRIMARY KEY (`prediction_id`),
		  UNIQUE KEY `idx_euro_prediction_um` (`user_id`,`match_id`),
		  INDEX  `idx_euro_prediction_wwhen` (  `wwhen` )
		) $charset_collate";
		$ret = $wpdb->query($sql);
		if ($ret === false) {
			error_log($wpdb->last_error);
		}
		
		
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}{$this->prefix}stage` (
		  `stage_id` int(11) NOT NULL AUTO_INCREMENT,
		  `stage_name` varchar(32) NOT NULL,
		  `is_group` tinyint(1) NOT NULL,
		  `sort_order` int(11) NOT NULL,
		  PRIMARY KEY (`stage_id`)
		) $charset_collate";
		$ret = $wpdb->query($sql);
		if ($ret === false) {
			error_log($wpdb->last_error);
		} else {
			$count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}stage");
			if (!$count) {
				$wpdb->query("INSERT INTO `{$wpdb->prefix}{$this->prefix}stage` (`stage_id`, `stage_name`, `is_group`, `sort_order`) VALUES
						(1, 'Group A', 1, 1),
						(2, 'Group B', 1, 2),
						(3, 'Group C', 1, 3),
						(4, 'Group D', 1, 4),
						(5, 'Quarter-finals', 0, 5),
						(6, 'Semi-finals', 0, 6),
						(7, 'Finals', 0, 7)");
			}
		}
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}{$this->prefix}team` (
		  `team_id` int(20) NOT NULL AUTO_INCREMENT,
		  `name` varchar(64) NOT NULL,
		  `country` char(3) NOT NULL,
		  `team_url` varchar(255) NOT NULL,
		  `group_order` int(11) NOT NULL,
		  PRIMARY KEY (`team_id`)
		) $charset_collate";
		$ret = $wpdb->query($sql);
		if ($ret === false) {
			error_log($wpdb->last_error);
		} else {
			$count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}team");
			if (!$count) {
				$wpdb->query("INSERT INTO `{$wpdb->prefix}{$this->prefix}team` (`team_id`, `name`, `country`, `team_url`, `group_order`) VALUES
						(1, 'Croatia', 'cro', '', 4),
						(2, 'Czech Republic', 'cze', '', 4),
						(3, 'Denmark', 'den', '', 2),
						(4, 'England', 'eng', '', 4),
						(5, 'France', 'fra', '', 3),
						(6, 'Germany', 'ger', '', 3),
						(7, 'Greece', 'gre', '', 2),
						(8, 'Italy', 'ita', '', 2),
						(9, 'Netherlands', 'ned', '', 1),
						(10, 'Poland', 'pol', '', 1),
						(11, 'Portugal', 'por', '', 4),
						(12, 'Republic of Ireland', 'irl', '', 3),
						(13, 'Russia', 'rus', '', 3),
						(14, 'Spain', 'esp', '', 1),
						(15, 'Sweden', 'swe', '', 2),
						(16, 'Ukraine', 'ukr', '', 1),
						(17, 'Winner Group A', 'xxx', '', 0),
						(18, 'Winner Group B', 'xxx', '', 0),
						(19, 'Winner Group C', 'xxx', '', 0),
						(20, 'Winner Group D', 'xxx', '', 0),
						(21, 'Runner-up Group A', 'xxx', '', 0),
						(22, 'Runner-up Group B', 'xxx', '', 0),
						(23, 'Runner-up Group C', 'xxx', '', 0),
						(24, 'Runner-up Group D', 'xxx', '', 0),
						(25, 'Winner Match 25', 'xxx', '', 0),
						(26, 'Winner Match 26', 'xxx', '', 0),
						(27, 'Winner Match 27', 'xxx', '', 0),
						(28, 'Winner Match 28', 'xxx', '', 0),
						(29, 'Winner Match 29', 'xxx', '', 0),
						(30, 'Winner Match 30', 'xxx', '', 0)");
			}
		}
		
		$sql = "CREATE TABLE IF NOT EXISTS `{$wpdb->prefix}{$this->prefix}venue` (
		  `venue_id` int(11) NOT NULL AUTO_INCREMENT,
		  `venue_name` varchar(64) NOT NULL,
		  `venue_url` varchar(255) NOT NULL,
		  `stadium` varchar(64) NOT NULL,
		  `tz_offset` int(11) NOT NULL,
		  PRIMARY KEY (`venue_id`)
		) $charset_collate";
		$ret = $wpdb->query($sql);
		if ($ret === false) {
			error_log($wpdb->last_error);
		} else {
			$count = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}venue");
			if (!$count) {
				$wpdb->query("INSERT INTO `{$wpdb->prefix}{$this->prefix}venue` (`venue_id`, `venue_name`, `venue_url`, `stadium`, `tz_offset`) VALUES
						(1, 'Warsaw', '', 'National Stadium', 2),
						(2, 'Gdańsk', '', 'PGE Arena', 2),
						(3, 'Wrocław', '', 'Municipal Stadium', 2),
						(4, 'Poznań', '', 'Municipal Stadium', 2),
						(5, 'Kiev', '', 'Olympic Stadium', 3),
						(6, 'Kharkiv', '', 'Metalist Stadium', 3),
						(7, 'Donetsk', '', 'Donbass Arena', 3),
						(8, 'Lviv', '', 'Arena Lviv', 3)");
			}
		}
		
		// Installed plugin database table version
		$installed_ver = get_option($this->prefix.'db_version');
		// If the database has changed, update the structure while preserving data
		if (empty($installed_ver) || $db_version != $installed_ver) {
			
			if (!empty($installed_ver) && $installed_ver == "1.0") {
				//update_option($this->prefix.'db_version', '1.1');
			}
			
		}
 		update_option($this->prefix.'db_version', $db_version);
		
 		add_option($this->prefix.'promo_link', 1);
 		add_option($this->prefix.'countdown_format', __('Next prediction deadline in', EURO_TD) . " %%D%%d, %%H%%h, %%M%%m, %%S%%s");
 		add_option($this->prefix.'browser_locale', 1);
 		
		/*
		 * Set Capabilities
		*/
		$role = get_role('administrator');
		$role->add_cap($this->prefix.'manager');	// Can manage players, teams etc.
		
		$role = get_role('editor');
		$role->add_cap($this->prefix.'manager');
		
		return true;
	}
	
	/**
	 * Deactivation hook.
	 */
	function deactivate() {
		return true;
	}
	
	
	/**
	 * Create admin menu
	 */
	function admin_menu() {
				
		require_once(dirname(__FILE__).'/menu.class.php');
		$menu = new Euro2012Menu();
		$scoring = new Euro2012Scoring();
		$overview = new Euro2012Overview();
		
		add_menu_page(__('Euro 2012 Menu', EURO_TD), __('Euro 2012', EURO_TD), $this->prefix.'manager', $this->prefix.'menu', array($overview, 'overview'), WP_PLUGIN_URL.'/'.EURO_TD .'/images/football.png');
		add_submenu_page($this->prefix.'menu' ,__('Overview', EURO_TD), __('Overview', EURO_TD), $this->prefix.'manager', $this->prefix.'menu' , array($overview, 'overview'));
		add_submenu_page($this->prefix.'menu' ,__('Teams and Matches', EURO_TD), __('Teams and Matches', EURO_TD), $this->prefix.'manager', $this->prefix.'config' , array($menu, 'menu'));
		add_submenu_page($this->prefix.'menu' ,__('Predictions', EURO_TD), __('Predictions', EURO_TD), $this->prefix.'manager', $this->prefix.'predictions' , array($scoring, 'menu'));
		add_submenu_page($this->prefix.'menu' ,__('Help', EURO_TD), __('Help', EURO_TD), $this->prefix.'manager', $this->prefix.'help' , array($this, 'help'));
	}
	
	/**
	 * Style sheet for admin functions
	 */
	function admin_print_styles() {
		wp_enqueue_style($this->prefix.'style', plugins_url('/css/style.css', dirname(__FILE__)));
		wp_enqueue_style($this->prefix.'admin-style', plugins_url('/css/admin-style.css', dirname(__FILE__)));
		wp_enqueue_style($this->prefix.'jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.2/themes/smoothness/jquery-ui.css');
	}

	/**
	 * Javascript for admin functions
	 */
	function admin_enqueue_scripts() {
		wp_enqueue_script($this->prefix.'admin_js', WP_PLUGIN_URL . '/' . EURO_TD . '/js/admin.js', array( 'jquery', 'jquery-ui-tabs', 'jquery-ui-dialog' ));
		wp_enqueue_script( 'postbox' );
	}
	
	/**
	 * Init hook
	 */
	function admin_init() {
		
		register_setting( $this->prefix.'option-group', $this->prefix.'promo_link');
		register_setting( $this->prefix.'option-group', $this->prefix.'countdown_format');
		register_setting( $this->prefix.'option-group', $this->prefix.'browser_locale');
	}
	

	function settings() {
?>		
	
	<form method="post" action="options.php">
	
	<?php settings_fields( $this->prefix.'option-group' );?>
	
	<table class="form-table">
	
	<tr valign="top">
	<th scope="row" colspan="2"><?php _e('Countdown clock format', EURO_TD); ?></th>
	</tr>
	<tr>
	<td colspan="2"><input style="font-family:'Courier New', Courier, monospace;" type="text" size="60" name="<?php echo $this->prefix; ?>countdown_format" value="<?php echo get_option($this->prefix.'countdown_format', __('Next prediction deadline in', EURO_TD) . ' %%D%%d, %%H%%h, %%M%%m, %%S%%s'); ?>" /></td>
	</tr>
	
	<tr valign="top">
	<th scope="row"><?php _e('Convert kickoff times to local timezone. If unchecked kickoff times are displayed as match local time', EURO_TD); ?></th>
	<td><input type="checkbox" id="<?php echo $this->prefix; ?>browser_locale" name="<?php echo $this->prefix; ?>browser_locale" value="1" <?php echo get_option($this->prefix.'browser_locale', 1) ? ' checked ' : ''; ?> /></td>
	</tr>

	<tr valign="top">
	<th scope="row"><?php _e('Link to Authors site in footer', EURO_TD); ?></th>
	<td><input type="checkbox" id="<?php echo $this->prefix; ?>promo_link" name="<?php echo $this->prefix; ?>promo_link" value="1" <?php echo get_option($this->prefix.'promo_link', 1) ? ' checked ' : ''; ?> /></td>
	</tr>
	
	</table>
	
	
	<p class="submit">
	<input type="submit" class="button" value="<?php _e('Save Changes', EURO_TD) ?>" />
	</p>
	</form>
		
<?php		
	}
	
	function help() {
		
		require_once(dirname(__FILE__).'/markdown.php');
		
		$help = file_get_contents(dirname(__FILE__).'/../readme.txt');
		if (empty($help)) {
			return '<h1>No Help</h1>';
		}
		
		// Fudge the header to markdown syntax
		$str = str_replace(array('===', '===','Contributors:',  'Donate link: http://www.ianhaycox.com/donate',  'Tags:',   'Requires at least:',  'Tested up to:',  'Stable tag:'),
						   array('=',   '=',  '* Contributors:','* Donate link: <a href="http://www.ianhaycox.com/donate">http://www.ianhaycox.com/donate</a>','* Tags:', '* Requires at least:','* Tested up to:','* Stable tag:'), $help);
		echo Markdown($str);
		return;
	}
	
	
	/**
	 * Set to current JQuery tab
	 * 
	 * @param int $i tab number indexed from 0
	 * @return none
	 */
	function selectTab($i) {
?>
		<script type="text/javascript">
		jQuery(function($) {
		  	$("#<?php echo $this->prefix; ?>tabs").tabs('select', <?php echo $i; ?>);
		});
		</script>
<?php 
	}

	/**
	 * Get a list of registered users in a dropdown select box
	 * 
	 * @param $player_id - Preselect this user
	 */
	function getUsers($user_id, $empty = true, $id = 'user_id', $empty_str = 'All Users') {
		global $wpdb;
		
		$sql = 'SELECT ID,user_login, display_name FROM '.$wpdb->users;
		
		$users = $wpdb->get_results( $sql , OBJECT );
		
		$output = '<select name="'.$id.'" id="'.$id.'">';
		if ($empty) $output .= '<option value = "-1">'.$empty_str.'</option>';

		foreach ($users as $row) {
			$output .= "<option ";
			if (!is_null($user_id) && $user_id == $row->ID) {
				$output .= " selected ";
			}
			$output .= "value=\"$row->ID\">$row->user_login ($row->display_name)</option>";
		}
		$output .= "</select>";
		
		return $output;
	}
	
	/**
	 * Gets the current date and time from the server
	 * 
	 * @return MySQL format date/time string YYYY-MM-DD HH:MM:SS
	 */
	function getServerDateTime() {
		global $wpdb;
		
		$sql = 'SELECT NOW() as "now"';
		$result = $wpdb->get_row( $sql , OBJECT );
		return $result->now;
		
	}
	
	/*
	 * Check is [+/-]HH:MM format
	 */
	function is_hhmm($s) {
		return (ereg ("^[+-]{0,1}([0-9]{2}):([0-9]{2})", $s));
	}
	
	/*
	 * Check YYYY-MM-DD HH:MM:SS format
	 */
	function is_datetime($d) {
		if (empty($d) || $d == '0000-00-00 00:00:00') return false;
		return (ereg ("([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})", $d));
	}
	
}