<?php
/**
 * Handle the main admin menu
 * 
 * @package Euro2012
 * @version $Id$
 * @author ian
 * Copyright Ian Haycox, 2012
 *
 */
class Euro2012Menu extends Euro2012Admin {


	function menu() {
		
		$teams = new Euro2012Teams(0);
		$venues = new Euro2012Venues(1);
		$stages = new Euro2012Stages(2);
		$matches = new Euro2012Matches(3);
		
?>
		<div class="wrap">
		
		<h2><?php _e('Euro 2012 Manager', EURO_TD) ?></h2>
		
		<div id="<?php echo $this->prefix; ?>tabs" class="ui-tabs">
		<ul class="ui-tabs-nav">
			<li><a href="#<?php echo $this->prefix; ?>tabs-1"><?php _e("Teams", EURO_TD); ?></a></li>
			<li><a href="#<?php echo $this->prefix; ?>tabs-2"><?php _e("Venues", EURO_TD); ?></a></li>
			<li><a href="#<?php echo $this->prefix; ?>tabs-3"><?php _e("Stages", EURO_TD); ?></a></li>
			<li><a href="#<?php echo $this->prefix; ?>tabs-4"><?php _e("Matches", EURO_TD); ?></a></li>
			<li><a href="#<?php echo $this->prefix; ?>tabs-5"><?php _e("Group Results", EURO_TD); ?></a></li>
			<li><a href="#<?php echo $this->prefix; ?>tabs-6"><?php _e("Knockout Results", EURO_TD); ?></a></li>
		</ul>

		<div id="<?php echo $this->prefix; ?>tabs-1" class="ui-tabs-hide">
			<?php echo $teams->teams(); ?>
		</div>
		
		<div id="<?php echo $this->prefix; ?>tabs-2" class="ui-tabs-hide">
			<?php echo $venues->venues(); ?>
		</div>
		
		<div id="<?php echo $this->prefix; ?>tabs-3" class="ui-tabs-hide">
			<?php echo $stages->stages(); ?>
		</div>
		
		<div id="<?php echo $this->prefix; ?>tabs-4" class="ui-tabs-hide">
			<?php echo $matches->matches(); ?>
		</div>
		
		<div id="<?php echo $this->prefix; ?>tabs-5" class="ui-tabs-hide">
			<?php echo $this->group_results(); ?>
		</div>
		
		<div id="<?php echo $this->prefix; ?>tabs-6" class="ui-tabs-hide">
			<?php echo $this->knockout_results(); ?>
		</div>
		</div>
		
		</div>
<?php
	}
	
	function group_results() {
		$report = new Euro2012Report();
		
?>
		<div class="wrap" style="padding-bottom:1em;">
		
		<h2><?php _e('Group Results', EURO_TD) ?></h2>

		<?php echo $report->group_tables(0, 1, '50%'); ?>
		
		</div>
<?php
		
	}
	
	function knockout_results() {
		$report = new Euro2012Report();
		
?>
		<div class="wrap" style="padding-bottom:1em;">
		
		<h2><?php _e('Knockout Results', EURO_TD) ?></h2>

		<?php echo $report->knockout(); ?>
		
		</div>
<?php
	}
	
}