<?php
/**
 * Handle the main admin welcome screen
 * 
 * @package Euro2012
 * @version $Id$
 * @author ian
 * Copyright Ian Haycox, 2012
 *
 */
class Euro2012Overview extends Euro2012Admin {
	
	
	function dashboard() {
		global $wpdb;
		$disabled = '';
		
		$teams    = intval( $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}team WHERE country <> 'xxx'") );
		$venues = intval( $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}venue") );
		$matches    = intval( $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}match") );
		$predictions = intval( $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}{$this->prefix}prediction") );
		
		if ($teams || $venues || $matches) {
			$disabled = ' disabled ';
		}
		
		?>
		
		<p class="sub"><?php _e('At a Glance', EURO_TD); ?></p>
		<div class="table">
			<table>
				<tbody>
					<tr class="first">
						<td class="first b"><?php echo $teams; ?></td>
						<td class="t"><?php echo _n( 'Team', 'Teams', $teams, EURO_TD ); ?></td>
					</tr>
					<tr class="first">
						<td class="first b"><?php echo $venues; ?></td>
						<td class="t"><?php echo _n( 'Venue', 'Venues', $venues, EURO_TD ); ?></td>
					</tr>
					<tr class="first">
						<td class="first b"><?php echo $matches; ?></td>
						<td class="t"><?php echo _n( 'Match', 'Matches', $matches, EURO_TD ); ?></td>
					</tr>
					<tr class="first">
						<td class="first b"><?php echo $predictions; ?></td>
						<td class="t"><?php echo _n( 'Prediction', 'Predictions', $predictions, EURO_TD ); ?></td>
					</tr>
				</tbody>
			</table>
		</div>
		<div class="versions">
			<p>
			<?php
				$userlevel = '<span class="b">' . (current_user_can($this->prefix . 'manager') ? __('Euro 2012 Manager', EURO_TD) : __('no', EURO_TD)) . '</span>';
		        printf(__('You currently have %s rights.', EURO_TD), $userlevel);
		    ?>
		    </p>
		</div>
		<?php
	}
	
	function news() {
			// get feed_messages
			require_once(ABSPATH . WPINC . '/feed.php');
		?>
		<div class="rss-widget">
			    <?php
			$feed_url = 'http://ianhaycox.com/euro2012/feed/rss2';
			$feed = @fetch_feed($feed_url);
			if ($feed && !isset($feed->errors)) {
				?><ul><?php 
				foreach ($feed->get_items(0, $feed->get_item_quantity(5)) as $item) {
			        ?>
			          <li><a class="rsswidget" title="" href='<?php echo wp_filter_kses($item->get_permalink()); ?>'><?php echo esc_html($item->get_title()); ?></a>
					  <span class="rss-date"><?php echo $item->get_date(); ?></span> 
			          <div class="rssSummary"><?php echo $item->get_description(); ?></div></li>
			        <?php
				}
				?></ul><?php 
			} else {
				echo '<p>' . sprintf(__('Feed could not be loaded.  Check the <a href="%s">front page</a> to check for updates.', EURO_TD), $feed_url) . '</p>';
			}
		    ?>
		</div>
		<?php
	}
	
	
	function donators() {
		$i = 0;
		$list = '';
		
		$supporter = $this->get_remote_array('http://ianhaycox.com/donations.php');
		
		// Ensure that this is a array
		if ( !is_array($supporter) )
			return _e('Thank you to all donators...', EURO_TD);
			
		$supporter = array_reverse($supporter);
		
		foreach ($supporter as $name => $url) {
			$i++;
			if ($url)
				$list .= "<li><a href=\"$url\">$name</a></li>\n";
			else
				$list .= "<li>$name</li>";
			if ($i > 6)
				break;
		}
		?>
		<div id="dashboard_server_settings" class="dashboard-widget-holder">
			<div class="euro-dashboard-widget">
			  	<div class="dashboard-widget-content">
			  		<ul class="euro2012-settings">
					<?php echo $list; ?>
					</ul>
					<p class="textright" style="margin-right:10px">
						<a href="http://www.ianhaycox.com/donate" title="<?php _e('Donate', EURO_TD); ?>"><img alt="<?php _e('Donate', EURO_TD); ?>" src="https://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" /></a>
					</p>
				</div>
		    </div>
		</div>
		<?php	
	}
	
	function get_server_info() {
		global $wpdb;
		
		// Get MYSQL Version
		$sqlversion = $wpdb->get_var("SELECT VERSION() AS version");
		// GET SQL Mode
		$mysqlinfo = $wpdb->get_results("SHOW VARIABLES LIKE 'sql_mode'");
		if (is_array($mysqlinfo)) $sql_mode = $mysqlinfo[0]->Value;
		if (empty($sql_mode)) $sql_mode = __('Not set', EURO_TD);
		// Get PHP Safe Mode
		if(ini_get('safe_mode')) $safe_mode = __('On', EURO_TD);
		else $safe_mode = __('Off', EURO_TD);
		
	?>
		<li><?php _e('Operating System', EURO_TD); ?> : <span><?php echo PHP_OS; ?></span></li>
		<li><?php _e('Server', EURO_TD); ?> : <span><?php echo $_SERVER["SERVER_SOFTWARE"]; ?></span></li>
		<li><?php _e('MYSQL Version', EURO_TD); ?> : <span><?php echo $sqlversion; ?></span></li>
		<li><?php _e('SQL Mode', EURO_TD); ?> : <span><?php echo $sql_mode; ?></span></li>
		<li><?php _e('PHP Version', EURO_TD); ?> : <span><?php echo PHP_VERSION; ?></span></li>
		<li><?php _e('PHP Safe Mode', EURO_TD); ?> : <span><?php echo $safe_mode; ?></span></li>
	<?php
	}
	
	function server() {
		?>
		<div id="dashboard_server_settings" class="dashboard-widget-holder wp_dashboard_empty">
			<div class="euro-dashboard-widget">
			  	<div class="dashboard-widget-content">
		      		<ul class="euro2012-settings">
		      		<?php $this->get_server_info(); ?>
			   		</ul>
				</div>
		    </div>
		</div>
		<?php	
	}
	
	function support() {
		?>
		<div id="dashboard_server_settings" class="dashboard-widget-holder wp_dashboard_empty">
			<div class="euro-dashboard-widget">
			  	<div class="dashboard-widget-content">
			  		<a href="http://www.ianhaycox.com/euro2012/forums">Support Forums</a>
				</div>
		    </div>
		</div>
		<?php	
	}
	
	function overview() {
		
		add_meta_box('dashboard_right_now', __('Welcome to Euro 2012 Predictor V ', EURO_TD) . self::VERSION, array(&$this, 'dashboard'), 'euro_overview', 'left', 'core');
		add_meta_box('dashboard_primary', __('Latest News', EURO_TD), array(&$this, 'news'), 'euro_overview', 'right', 'core');
		add_meta_box('euro_donators', __('Recent donators', EURO_TD), array(&$this, 'donators'), 'euro_overview', 'right', 'core');
		add_meta_box('euro_server', __('Server Settings', EURO_TD), array(&$this, 'server'), 'euro_overview', 'right', 'core');
		add_meta_box('euro_settings', __('Settings', EURO_TD), array(&$this, 'settings'), 'euro_overview', 'left', 'core');
		add_meta_box('euro_support', __('Support', EURO_TD), array(&$this, 'support'), 'euro_overview', 'left', 'core');
		
		if (isset($_POST[$this->prefix.'import'])) {
			$this->import();
		}
	?>
	<div class="wrap euro-wrap">
		<h2><?php _e('Euro 2012 Predictor Overview', EURO_TD) ?></h2>
		<div id="dashboard-widgets-wrap" class="euro-overview">
		    <div id="dashboard-widgets" class="metabox-holder">
				<div id="post-body">
					<div id="dashboard-widgets-main-content">
						<div class="postbox-container" style="width:49%;">
							<?php do_meta_boxes('euro_overview', 'left', ''); ?>
						</div>
			    		<div class="postbox-container" style="width:49%;">
							<?php do_meta_boxes('euro_overview', 'right', ''); ?>
						</div>						
					</div>
				</div>
		    </div>
		</div>
	</div>
	<script type="text/javascript">
		//<![CDATA[
		jQuery(document).ready( function($) {
			// postboxes setup
			postboxes.add_postbox_toggles('wcc-overview');
		});
		//]]>
	</script>
	<?php
		
	}

	/**
	 * Read an array from a remote url
	 * 
	 * @param string $url
	 * @return array of the content
	 */
	function get_remote_array($url) {
		if ( function_exists('wp_remote_request') ) {
					
			$options = array();
			$options['headers'] = array(
				'User-Agent' => 'Euro 2012 Predictor V' . self::VERSION . '; (' . get_bloginfo('url') .')'
			 );
			 
			$response = wp_remote_request($url, $options);
			
			if ( is_wp_error( $response ) )
				return false;
		
			if ( 200 != $response['response']['code'] )
				return false;
		   	
			$content = unserialize($response['body']);
	
			if (is_array($content)) 
				return $content;
		}
		
		return false;	
	}

	function import() {
		global $wpdb;
		$this->setMessage(__('Match data imported', EURO_TD));
		$this->printMessage();
		
	}

}
